//+------------------------------------------------------------------+
//|                                  candlestickPatternIndicator.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Marcus"
#property link      "http://www.binaryoptionsedge.com/topic/3693-yet-another-candlestick-pattern-indicator/"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 2

extern color bearishTextColor = Red;
extern color bullishTextColor = Green;
extern color bearishSymbolColor = Red;
extern color bullishSymbolColor = Green;

extern int  checkChartOnRemainingXSeconds       = 0;
extern bool showAllBearish                      = false;
extern bool showAllBullish                      = false;
extern char showBearishHangingMan               = -1;
extern char showBullishHammer                   = -1;
extern char showBearishEngulfing                =  1;
extern char showBullishEngulfing                =  1;
extern char showBearishHarami                   = -1;
extern char showBullishHarami                   = -1;
extern char showBearishHaramiCross              = -1;
extern char showBullishHaramiCross              = -1;
extern char showBearishShootingStar             = -1;
extern char showBullishInvertedHammer           = -1;
extern char showBearishDarkCloud                = -1;
extern char showBullishPiercingLine             = -1;
extern char showBearishDojiStar                 = -1;
extern char showBullishDojiStar                 = -1;
extern char showBearishMeetingLine              = -1;
extern char showBullishMeetingLine              = -1;
extern char showBearishDescendingHawk           = -1;
extern char showBullishHomingPigeon             = -1;
extern char showBearishMatchingHigh             = -1;
extern char showBullishMatchingLow              = -1;
extern char showBearishOneBlackCrow             = -1;
extern char showBullishOneWhiteSoldier          = -1;
extern char showBearishEveningStar              = -1;
extern char showBullishMorningStar              = -1;
extern char showBearishEveningDojiStar          = -1;
extern char showBullishMorningDojiStar          = -1;
extern char showBearishAbandonedBaby            = -1;
extern char showBullishAbandonedBaby            = -1;
extern char showBearishTriStar                  = -1;
extern char showBullishTriStar                  = -1;
extern char showBearishUpsideGapTwoCrows        = -1;
extern char showBullishDownsideGapTwoRabbits    = -1;
extern char showBearishUniqueThreeMountainTop   = -1;
extern char showBullishUniqueThreeRiverBottom   = -1;
extern char showBearishThreeBlackCrows          = -1;
extern char showBullishThreeWhiteSoldiers       = -1;
extern char showBearishAdvanceBlock             = -1;
extern char showBullishDescentBlock             = -1;
extern char showBearishDeliberationBlock        = -1;
extern char showBullishDeliberationBlock        = -1;
extern char showBearishTwoCrows                 = -1;
extern char showBullishTwoRabbits               = -1;
extern char showBearishThreeInsideDown          = -1;
extern char showBullishThreeInsideUp            = -1;
extern char showBearishThreeOutsideDown         = -1;
extern char showBullishThreeOutsideUp           = -1;
extern char showBearishSqueezeAlert             = -1;
extern char showBullishSqueezeAlert             = -1;
extern char showBearishThreeGapUps              = -1;
extern char showBullishThreeGapDowns            = -1;
extern char showBearishBreakaway                = -1;
extern char showBullishBreakaway                = -1;
extern char showBearishLadderTop                = -1;
extern char showBullishLadderBottom             = -1;
extern char showBearishAfterTopGapDown          = -1;
extern char showBullishAfterBottomGapUp         = -1;
extern char showBearishSeparatingLines          = -1;
extern char showBullishSeparatingLines          = -1;
extern char showBearishFallingThreeMethods      = -1;
extern char showBullishRisingThreeMethods       = -1;
extern char showBearishDownsideTasukiGap        = -1;
extern char showBullishUpsideTasukiGap          = -1;
extern char showBearishDownsideGapThreeMethods  = -1;
extern char showBullishUpsideGapThreeMethods    = -1;
extern char showBearishInNeck                   = -1;
extern char showBullishInNeck                   = -1;
extern char showBearishOnNeck                   = -1;
extern char showBullishOnNeck                   = -1;
extern char showBearishSideBySideWhiteLines     = -1;
extern char showBullishSideBySideWhiteLines     = -1;

double upArrow[];
double downArrow[];

int init() {
   SetIndexStyle(0,DRAW_ARROW, EMPTY, EMPTY, bearishSymbolColor);
   SetIndexArrow(0,234);
   SetIndexBuffer(0, downArrow);
      
   SetIndexStyle(1,DRAW_ARROW, EMPTY, EMPTY, bullishSymbolColor);
   SetIndexArrow(1,233);
   SetIndexBuffer(1, upArrow);

   return(0);
}

int deinit() {
   ObjectsDeleteAll(0, OBJ_TEXT);
   return(0);
}

int start(){
   static datetime prevtime = 0;

   if(prevtime == Time[0]) {
      int leftTime=(Period()*60)-(TimeCurrent()-Time[0]);
      if (leftTime <= checkChartOnRemainingXSeconds)
         findIndicators(0, Bars);
      return(0);
   }
   prevtime = Time[0];
   
   
   
   findIndicators(1, Bars);
   return(0);
}

void drawBearish(int bar, int Pointer_Offset, int High_Offset, int& CumOffset, int IncOffset, string pattern) {
   downArrow[bar] = High[bar] + (Pointer_Offset*Point);
   ObjectCreate( "bearish" + pattern + DoubleToStr(Time[bar],0), OBJ_TEXT, 0, Time[bar], High[bar] + (Pointer_Offset+High_Offset+CumOffset)*Point);
   ObjectSetText("bearish" + pattern + DoubleToStr(Time[bar],0), pattern, 6, "Times New Roman", bearishTextColor);
   CumOffset += IncOffset;
}

void drawBullish(int bar, int Pointer_Offset, int& CumOffset, int IncOffset, string pattern) {
   upArrow[bar] = Low[bar] - (Pointer_Offset*Point);
   ObjectCreate( "bullish" + pattern + DoubleToStr(Time[bar],0), OBJ_TEXT, 0, Time[bar], Low[bar] - (Pointer_Offset+CumOffset)*Point);
   ObjectSetText("bullish" + pattern + DoubleToStr(Time[bar],0), pattern, 6, "Times New Roman", bullishTextColor);
   CumOffset += IncOffset;
}

void destroyBearish(int bar, string pattern, int CumOffset) {
   string objName = "bearish" + pattern + DoubleToStr(Time[bar],0);
   if (!ObjectFind(objName)) {
      ObjectDelete(objName);
      if (!CumOffset) {
         downArrow[bar] = EMPTY_VALUE;
      }
   }
}

void destroyBullish(int bar, string pattern, int CumOffset) {
   string objName = "bullish" + pattern + DoubleToStr(Time[bar],0);
   if (!ObjectFind(objName)) {
      ObjectDelete(objName);
      if (!CumOffset) {
         upArrow[bar] = EMPTY_VALUE;
      }
   }
}

bool isInsideBar(int smallerBar, int biggerBar, bool lowInsideStart = true, bool lowInsidelow = true, bool highInsideFinish = true, bool highInsideHigh = true, double difStartMin = 0.0, double difFinishMin = 0.0) {
   bool isInsideBar = true;
   isInsideBar = fmin(Open[smallerBar], Close[smallerBar]) - fmin(Open[biggerBar], Close[biggerBar]) >= difStartMin ? true : false;
   if (!isInsideBar) return false;
   isInsideBar = fmax(Open[biggerBar], Close[biggerBar]) - fmax(Open[smallerBar], Close[smallerBar]) >= difFinishMin ? true : false;
   if (!isInsideBar) return false;
   isInsideBar = lowInsideStart ? (Low[smallerBar] - fmin(Open[biggerBar], Close[biggerBar]) >= 0.0 ? true : false)
   : lowInsidelow ? (Low[smallerBar] - Low[biggerBar] >= 0.0 ? true : false) : isInsideBar;
   if (!isInsideBar) return false;
   isInsideBar = highInsideFinish ? (fmax(Open[biggerBar], Close[biggerBar]) - High[smallerBar] >= 0.0 ? true : false)
   : highInsideHigh ? (High[biggerBar] - High[smallerBar] >= 0.0 ? true : false) : isInsideBar;
   return isInsideBar;
}

bool isUptrend(int barStart, int nbars, double difFinishMin = 0.0f, bool startInsideStart = true, bool highInsideHigh = true, bool bullMovesOnly = false, bool startAfterFinish = false, bool lowInsideLow = false) {
   bool isUptrend = true;
      
   for (int j = barStart; j < barStart + nbars; ++j) {
      if (bullMovesOnly && isBearish(j))
         return false;
   }

   for (int i = barStart; i < barStart + nbars - 1; ++i) {
      double finishI = fmax(Open[i], Close[i]), finishIplusOne = fmax(Open[i + 1], Close[i + 1]),
             startI = fmin(Open[i], Close[i]), startIplusOne = fmin(Open[i + 1], Close[i + 1]);

      isUptrend = finishI - finishIplusOne >= difFinishMin ? true : false;
      if (!isUptrend) return false;
      isUptrend = startAfterFinish ? (startI - finishIplusOne >= 0.0 ? true : false)
      : startInsideStart ? (startI - startIplusOne >= 0.0 ? true : false) : isUptrend;
      if (!isUptrend) return false;
      isUptrend = lowInsideLow ? (Low[i] - Low[i + 1] >= 0.0 ? true : false) : isUptrend;
      if (!isUptrend) return false;
      isUptrend = highInsideHigh ? (High[i] - High[i + 1] >= 0.0 ? true : false) : isUptrend;
      if (!isUptrend) return false;
      
   }

   return isUptrend;
   
}
//int barStart, int nbars, double difFinishMin = 0.0f, bool startInsideStart = true, bool highInsideHigh = true, bool bullMovesOnly = false, bool startAfterFinish = false, bool lowInsideLow = false
bool isDowntrend(int barStart, int nbars, double difStartMin = 0.0f, bool finishInsideFinish = true, bool lowInsideLow = true, bool bearishMovesOnly = false, bool finishAfterStart = false, bool highInsideHigh = false) {
   bool isDowntrend = true;
   
   for (int j = barStart; j < barStart + nbars; ++j) {
      if (bearishMovesOnly && isBullish(j))
         return false;
   }
   
   for (int i = barStart; i < barStart + nbars - 1; ++i) {
      double finishI = fmax(Open[i], Close[i]), finishIplusOne = fmax(Open[i + 1], Close[i + 1]),
             startI = fmin(Open[i], Close[i]), startIplusOne = fmin(Open[i + 1], Close[i + 1]);
   
      isDowntrend = startIplusOne - startI >= difStartMin ? true : false;
      if (!isDowntrend) return false;
      isDowntrend = finishAfterStart ? (startIplusOne - finishI >= 0.0 ? true : false)
      : finishInsideFinish ? (finishIplusOne - finishI >= 0.0 ? true : false) : isDowntrend;
      if (!isDowntrend) return false;
      isDowntrend = lowInsideLow ? (Low[i + 1] - Low[i] >= 0.0 ? true : false) : isDowntrend;
      if (!isDowntrend) return false;
      isDowntrend = highInsideHigh ? (High[i + 1] - High[i] >= 0.0 ? true : false) : isDowntrend;
      if (!isDowntrend) return false;
   }
   
   return isDowntrend;
   
}

bool isBearish(int bar) {
   return Open[bar] > Close[bar];
}
bool isBullish(int bar) {
   return Open[bar] < Close[bar];
}
double getLength(int bar) {
   return High[bar] - Low[bar];
}
double getMiddleBodyPos(int bar) {
   return (Open[bar] + Close[bar])/2;
}
double getBodySize(int bar) {
   return isBullish(bar) ? Close[bar] - Open[bar] : Open[bar] - Close[bar];
}
double getUpperShadowSize(int bar) {
   return isBullish(bar) ? High[bar] - Close[bar] : High[bar] - Open[bar];
}
double getLowerShadowSize(int bar) {
   return isBullish(bar) ? Open[bar] - Low[bar] : Close[bar] - Low[bar];
}
bool isDoji(int bar) {
   return Open[bar] == Close[bar] && !(Low[bar] == Open[bar] && High[bar] == Open[bar]) ? true : false;
}
bool isLongBodied(int bar) {
   return getBodySize(bar) >= 0.5 * getLength(bar);
}
bool hasLongUpperWickWithAlmostToNoneLowerWick(int bar, double xTimesBiggerThanBodySize) {
   return getUpperShadowSize(bar) >= getBodySize(bar) * xTimesBiggerThanBodySize && getBodySize(bar) >= getLowerShadowSize(bar);
}
bool hasLongLowerWickWithAlmostToNoneUpperWick(int bar, double xTimesBiggerThanBodySize) {
   return getLowerShadowSize(bar) >= getBodySize(bar) * xTimesBiggerThanBodySize && getBodySize(bar) >= getUpperShadowSize(bar);
}

void findIndicators(int b, int n) {
   int  Pointer_Offset = 0;// The offset value for the arrow to be located off the candle high or low point.
   int  High_Offset = 0;// The offset value added to the high arrow pointer for correct plotting of the pattern label.
   int  CumOffset = 0;              // The counter value to be added to as more candle types are met.
   int  IncOffset = 0;              // The offset value that is added to a cummaltive offset value for each pass through the routine so any 
                                    // additional candle patterns that are also met, the label will print above the previous label.
   switch (Period()) {
      case 1:
         Pointer_Offset = 9;
         High_Offset = 15;
         IncOffset = 16;
         break;
      case 5:
         Pointer_Offset = 9;
         High_Offset = 15;
         IncOffset = 16;
         break;
      case 15:
         Pointer_Offset = 9;
         High_Offset = 15;
         IncOffset = 16;
         break;
      case 30:
         Pointer_Offset = 9;
         High_Offset = 15;
         IncOffset = 16;
         break;      
      case 60:
         Pointer_Offset = 9;
         High_Offset = 20;
         IncOffset = 18;
         break;
      case 240:
         Pointer_Offset = 20;
         High_Offset = 40;
         IncOffset = 25;
         break;
      case 1440:
         Pointer_Offset = 9;
         High_Offset = 80;
         IncOffset = 60;
         break;
      case 10080:
         Pointer_Offset = 9;
         High_Offset = 35;
         IncOffset = 35;
         break;
      case 43200:
         Pointer_Offset = 9;
         High_Offset = 45;
         IncOffset = 45;
         break;
   }
   
   for (int bar = b; bar < n; ++bar) {
      string pattern = "";
      CumOffset = 0;
      //Bearish Patterns
      
      //after top gap down
      if (showBearishAfterTopGapDown >= 1 || showBearishAfterTopGapDown == -1 && showAllBearish) {
         pattern = "AFTER TOP GAP DOWN";
         if (isUptrend(bar + 2, 2, 0.0, true, true, true, true) && isUptrend(bar + 3, 2, 0.0, true, true, true) && isDowntrend(bar, 2, 0.0f, true, true, true, true) && isDowntrend(bar + 1, 2, 0.0f, true, true)
         && Open[bar] < Close[bar + 3] && Close[bar] < Open[bar + 3]
         ) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //three gap ups
      if (showBearishThreeGapUps >= 1 || showBearishThreeGapUps == -1 && showAllBearish) {
         pattern = "THREE GAP UPS";
         if (isBullish(bar) && isBullish(bar + 1) && isUptrend(bar, 2, 4 * Point) && isUptrend(bar + 1, 3, 4 * Point) && isLongBodied(bar) && isLongBodied(bar + 1)){
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish ladder top
      if (showBearishLadderTop >= 1 || showBearishLadderTop == -1 && showAllBearish) {
         pattern = "LADDER TOP";
         if (isUptrend(bar + 1, 4, 0.0f, true, true, true) && hasLongLowerWickWithAlmostToNoneUpperWick(bar + 1, 1.75) && isBearish(bar) && Open[bar] <= Open[bar + 1] && Close[bar] <= Open[bar + 2] && isLongBodied(bar + 2) && isLongBodied(bar + 3) && isLongBodied(bar + 4)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish breakaway
      if (showBearishBreakaway >= 1 || showBearishBreakaway == -1 && showAllBearish) {
         pattern = "BREAKAWAY";
         if (isUptrend(bar + 3, 2, 0.0f, true, true, true)  &&
             getBodySize(bar + 4) >= 2 * getBodySize(bar + 3) &&
             isUptrend(bar + 1, 3, 0.0f, true, false) &&
             isDowntrend(bar, 2) && Close[bar] <= Open[bar + 3]
         ) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //three black crows
      if (showBearishThreeBlackCrows >= 1 || showBearishThreeBlackCrows == -1 && showAllBearish) {
         pattern = "THREE BLACK CROWS";
         if (isDowntrend(bar, 3, 3.0 * Point, true, false, true) && isLongBodied(bar) && isLongBodied(bar + 1) && isLongBodied(bar + 2)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish separating lines
      if (showBearishSeparatingLines >= 1 || showBearishSeparatingLines == -1 && showAllBearish) {
         pattern = "SEPARATING LINES";
         if (isBearish(bar) && isBullish(bar + 1) && isLongBodied(bar) && isLongBodied(bar + 1) &&
            isDowntrend(bar, 2, 0.0f, true, true, false, true)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish squeeze alert
      if (showBearishSqueezeAlert >= 1 || showBearishSqueezeAlert == -1 && showAllBearish) {
         pattern = "SQUEEZE ALERT";
         if (isInsideBar(bar, bar + 1) && isInsideBar(bar + 1, bar + 2) && isBullish(bar + 2)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //advance block
      if (showBearishAdvanceBlock >= 1 || showBearishAdvanceBlock == -1 && showAllBearish) {
         pattern = "ADVANCE BLOCK";
         if (isUptrend(bar, 3, 0.0f, true, true, true, false, true)
         && isLongBodied(bar + 2) && isLongBodied(bar + 1) && isLongBodied(bar)
         && getBodySize(bar + 2) > getBodySize(bar + 1) && getBodySize(bar + 1) > getBodySize(bar)
         && getUpperShadowSize(bar + 2) < getUpperShadowSize(bar + 1) && getUpperShadowSize(bar + 1) < getUpperShadowSize(bar)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish deliberation block
      if (showBearishDeliberationBlock >= 1 || showBearishDeliberationBlock == -1 && showAllBearish) {
         pattern = "DELIBERATION BLOCK";
         if (isUptrend(bar, 2, 0.0, true, true, true, true) && getBodySize(bar) < getBodySize(bar + 1) && getBodySize(bar) <= 5 * Point && isBullish(bar + 2) && isUptrend(bar + 1, 2, 0.0) && isLongBodied(bar) && isLongBodied(bar + 1) && isLongBodied(bar + 2)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish tri star
      if (showBearishTriStar >= 1 || showBearishTriStar == -1 && showAllBearish) {
         pattern = "TRI STAR";
         if (isDoji(bar) && isDoji(bar + 1) && isDoji(bar + 2) && Open[bar + 1] > Open[bar + 2] && Open[bar + 1] > Open[bar] && Open[bar] > Open[bar + 2]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish abandoned baby
      if (showBearishAbandonedBaby >= 1 || showBearishAbandonedBaby == -1 && showAllBearish) {
         pattern = "ABANDONED BABY";
         if (isBearish(bar) && isBullish(bar + 2) && getBodySize(bar + 1) <= 5 * Point && isLongBodied(bar) && isLongBodied(bar + 2) && getLength(bar + 1) < getLength(bar) && High[bar] < Low[bar + 1] && Close[bar] < Close[bar + 2] && High[bar + 2] < Low[bar + 1]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //evening doji star
      if (showBearishEveningDojiStar >= 1 || showBearishEveningDojiStar == -1 && showAllBearish) {
         pattern = "EVENING DOJI STAR";
         if (isBearish(bar) && isBullish(bar + 2) && isDoji(bar + 1) && isLongBodied(bar) && isLongBodied(bar + 2) && getLength(bar + 1) < getLength(bar) && getLength(bar + 1) < getLength(bar + 2) && Open[bar] <= Low[bar + 1] && Close[bar] < Close[bar + 2] && Close[bar + 2] <= Low[bar + 1]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //evening star
      if (showBearishEveningStar >= 1 || showBearishEveningStar == -1 && showAllBearish) {
         pattern = "EVENING STAR";
         if (!isDoji(bar + 1) && isBearish(bar) && isBullish(bar + 2) && isUptrend(bar + 1, 2, 0.0f, true, true, false, false, true) && isDowntrend(bar, 2, 0.0f, true, true, false, false, true) &&
         Close[bar] < Close[bar + 2] && Close[bar] > Open[bar + 2] && getLength(bar + 1) < getLength(bar) && getLength(bar + 1) < getLength(bar + 2) && getLength(bar) >= 0.5 * getLength(bar + 2) && isLongBodied(bar) && isLongBodied(bar + 2)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //two crows
      if (showBearishTwoCrows >= 1 || showBearishTwoCrows == -1 && showAllBearish) {
         pattern = "TWO CROWS";
         if (isBearish(bar) && isBearish(bar + 1) && isBullish(bar + 2) && isLongBodied(bar + 2) && isLongBodied(bar + 1)
         && isLongBodied(bar) && Close[bar + 1] >= Close[bar + 2] && Open[bar] <= Open[bar + 1] &&
         Open[bar] >= Close[bar + 1] && Close[bar] <= Close[bar + 2] && Close[bar] >= Open[bar + 2]
         && getLength(bar) >= 0.5 * getLength(bar + 2)
         ) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //shooting star
      if (showBearishShootingStar >= 1 || showBearishShootingStar == -1 && showAllBearish) {
         pattern = "SHOOTING STAR";
         if (isUptrend(bar, 2, 0.0f, true, true, false, true, true) && hasLongUpperWickWithAlmostToNoneLowerWick(bar, 1.9) && getUpperShadowSize(bar) >= 1.75 * getUpperShadowSize(bar + 1)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish harami cross
      if (showBearishHaramiCross >= 1 || showBearishHaramiCross == -1 && showAllBearish) {
         pattern = "HARAMI CROSS";
         if (isDoji(bar) && isBullish(bar + 1) && isInsideBar(bar, bar + 1)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish doji star
      if (showBearishDojiStar >= 1 || showBearishDojiStar == -1 && showAllBearish) {
         pattern = "DOJI STAR";
         if (isBullish(bar + 1) && isLongBodied(bar + 1) && isUptrend(bar, 2, 0.0f, true, true, false, true, true) && isDoji(bar) && Low[bar] >= Close[bar + 1]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //hanging man
      if (showBearishHangingMan >= 1 || showBearishHangingMan == -1 && showAllBearish) {
         pattern = "HANGING MAN";
         if (isUptrend(bar, 2) && hasLongLowerWickWithAlmostToNoneUpperWick(bar, 1.9) && getLowerShadowSize(bar) >= 1.75 * getLowerShadowSize(bar + 1)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //unique three mountain top
      if (showBearishUniqueThreeMountainTop >= 1 || showBearishUniqueThreeMountainTop == -1 && showAllBearish) {
         pattern = "UNIQUE THREE MOUNTAIN TOP";
         if (isBearish(bar) && isBullish(bar + 1) && isBullish(bar + 2) && isInsideBar(bar + 1, bar + 2, true, true, false, false) && High[bar + 1] > High[bar + 2]
         && Close[bar] < Close[bar + 2] && getLength(bar) < getUpperShadowSize(bar + 1)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //dark cloud
      if (showBearishDarkCloud >= 1 || showBearishDarkCloud == -1 && showAllBearish) {
         pattern = "DARK CLOUD";
         if (isBearish(bar) && isBullish(bar + 1) && isUptrend(bar, 2) && Close[bar] < getMiddleBodyPos(bar + 1) && Close[bar] > Open[bar + 1] && isLongBodied(bar) && isLongBodied(bar + 1)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //upside gap two crows
      if (showBearishUpsideGapTwoCrows >= 1 || showBearishUpsideGapTwoCrows == -1 && showAllBearish) {
         pattern = "UPSIDE GAP TWO CROWS";
         if (isBearish(bar) && isBearish(bar + 1) && isBullish(bar + 2) && Low[bar + 1] >= Close[bar + 2] && isInsideBar(bar + 1, bar)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish three outside down
      if (showBearishThreeOutsideDown >= 1 || showBearishThreeOutsideDown == -1 && showAllBearish) {
         pattern = "THREE OUTSIDE DOWN";
         if (isBearish(bar) && isBearish(bar + 1) && isBullish(bar + 2) && isInsideBar(bar + 2, bar + 1, false, false, false, false) && Close[bar] < Close[bar + 1]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish engulfing
      if (showBearishEngulfing >= 1 || showBearishEngulfing == -1 && showAllBearish) {
         pattern = "ENGULFING";
         if (isBearish(bar) && isBullish(bar + 1) && isInsideBar(bar + 1, bar, false, false, false, false) && Low[bar + 1] >= Close[bar]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish three inside down
      if (showBearishThreeInsideDown >= 1 || showBearishThreeInsideDown == -1 && showAllBearish) {
         pattern = "THREE INSIDE DOWN";
         if (isBearish(bar) && isBearish(bar + 1) && isBullish(bar + 2) && isInsideBar(bar + 1, bar + 2, false, false, false, false) && isLongBodied(bar) && Close[bar] < Close[bar + 1]
            && getBodySize(bar + 1) >= 0.4 * getBodySize(bar + 2)
         ) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish harami
      if (showBearishHarami >= 1 || showBearishHarami == -1 && showAllBearish) {
         pattern = "HARAMI";
         if (isBearish(bar) && isBullish(bar + 1) && isInsideBar(bar, bar + 1, false, false, false, false) && isLongBodied(bar)
         && getBodySize(bar) >= 0.4 * getBodySize(bar + 1)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish meeting line
      if (showBearishMeetingLine >= 1 || showBearishMeetingLine == -1 && showAllBearish) {
         pattern = "MEETING LINE";
         if (isBearish(bar) && isBullish(bar + 1) && isLongBodied(bar) && isLongBodied(bar + 1) && isUptrend(bar, 2, 0.0f, true, true, false, true)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //descending hawk
      if (showBearishDescendingHawk >= 1 || showBearishDescendingHawk == -1 && showAllBearish) {
         pattern = "DESCENDING HAWK";
         if (isBullish(bar) && isBullish(bar + 1) && isInsideBar(bar, bar + 1, false, false, false, false)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //matching high
      if (showBearishMatchingHigh >= 1 || showBearishMatchingHigh == -1 && showAllBearish) {
         pattern = "MATCHING HIGH";
         if (isBullish(bar) && isBullish(bar + 1) && isLongBodied(bar) && isLongBodied(bar + 1) && Open[bar + 1] < Open[bar] && Close[bar] == Close[bar + 1]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //one black crow
      if (showBearishOneBlackCrow >= 1 || showBearishOneBlackCrow == -1 && showAllBearish) {
         pattern = "ONE BLACK CROW";
         if (isBearish(bar) && isBullish(bar + 1) && isDowntrend(bar, 2) && Open[bar] > Open[bar + 1]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //Falling Three Methods
      if (showBearishFallingThreeMethods >= 1 || showBearishFallingThreeMethods == -1 && showAllBearish) {
         pattern = "FALLING THREE METHODS";
         if (isBearish(bar) && isBearish(bar + 4) && isLongBodied(bar) && isLongBodied(bar + 4) && isUptrend(bar + 1, 3, 0.0f, false, false) &&
            isInsideBar(bar + 3, bar + 4, false, false, false, false) && isInsideBar(bar + 2, bar + 4, false, false, false, false) && isInsideBar(bar + 1, bar + 4, false, false, false, false)
            && Close[bar] < Close[bar + 4]
            ) {
               drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
         
      //downside tasuki gap
      if (showBearishDownsideTasukiGap >= 1 || showBearishDownsideTasukiGap == -1 && showAllBearish) {
         pattern = "DOWNSIDE TASUKI GAP";
         if (isBullish(bar) && isBearish(bar + 1) && isBearish(bar + 2) && Low[bar + 2] > High[bar + 1] && Close[bar] <= Low[bar + 2] && Low[bar] >= Open[bar + 1]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //downside gap three methods
      if (showBearishDownsideGapThreeMethods>= 1 || showBearishDownsideGapThreeMethods == -1 && showAllBearish) {
         pattern = "DOWNSIDE GAP THREE METHODS";
         if (isBullish(bar) && isBearish(bar + 1) && isBearish(bar + 2) && Low[bar + 2] >= High[bar + 1] && Open[bar] <= Open[bar + 1] && Open[bar] > Close[bar + 1] && Close[bar] >= Close[bar + 2] && Close[bar] < Open[bar + 2]) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish in neck
      if (showBearishInNeck >= 1 || showBearishInNeck == -1 && showAllBearish) {
         pattern = "IN NECK";
         if (isBearish(bar + 1) && isBullish(bar) && isLongBodied(bar + 1) && Open[bar] < Low[bar + 1] && Close[bar] <= Close[bar + 1] - 2 * Point && Close[bar] > Close[bar + 1] && Close[bar] < Open[bar + 1]){
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bearish on neck
      if (showBearishOnNeck >= 1 || showBearishOnNeck == -1 && showAllBearish) {
         pattern = "ON NECK";
         if (isBearish(bar + 1) && isBullish(bar) && isLongBodied(bar + 1) && isLongBodied(bar) && Close[bar] == Low[bar + 1] && getBodySize(bar) < getBodySize(bar + 1)){
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //Bearish Side by Side White Lines
      if (showBearishSideBySideWhiteLines >= 1 || showBearishSideBySideWhiteLines == -1 && showAllBearish) {
         pattern = "SIDE BY SIDE WHITE LINES";
         if (isBullish(bar) && isBullish(bar + 1) && isBearish(bar + 2) && fabs(getBodySize(bar) - getBodySize(bar + 1)) <= Point && fabs(Open[bar] - Open[bar + 1]) <= Point && Open[bar] >= Close[bar + 2] && isLongBodied(bar) && isLongBodied(bar + 1) && isLongBodied(bar + 2)) {
            drawBearish(bar, Pointer_Offset, High_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBearish(bar, pattern, CumOffset);
      }
      
      //bullish patterns
      //after bottom gap up
      if (showBullishAfterBottomGapUp >= 1 || showBullishAfterBottomGapUp == -1 && showAllBullish) {
         pattern = "AFTER TOP GAP DOWN";
         if (isDowntrend(bar + 2, 2, 0.0, true, true, true, true) && isDowntrend(bar + 3, 2, 0.0, true, true, true) && isUptrend(bar, 2, 0.0f, true, true, true, true) && isUptrend(bar + 1, 2, 0.0f, true, true)
         && Open[bar] < Close[bar + 3] && Close[bar] < Open[bar + 3]
         ) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //three gap downs
      if (showBullishThreeGapDowns >= 1 || showBullishThreeGapDowns == -1 && showAllBullish) {
         pattern = "THREE GAP DOWNS";
         if (isBearish(bar) && isBearish(bar + 1) && isDowntrend(bar, 2, 4 * Point) && isDowntrend(bar + 1, 3, 4 * Point) && isLongBodied(bar) && isLongBodied(bar + 1)
            && isLongBodied(bar + 2) && isLongBodied(bar + 3) && High[bar] < High[bar + 1]){
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //ladder bottom
      if (showBullishLadderBottom >= 1 || showBullishLadderBottom == -1 && showAllBullish) {
         pattern = "LADDER BOTTOM";
         if (isDowntrend(bar + 1, 4, 0.0f, true, true, true) && hasLongUpperWickWithAlmostToNoneLowerWick(bar + 1, 1.75) && isBullish(bar) && Open[bar] >= Open[bar + 1] && Close[bar] >= Open[bar + 2] && isLongBodied(bar + 2) && isLongBodied(bar + 3) && isLongBodied(bar + 4)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish breakaway
      if (showBullishBreakaway >= 1 || showBullishBreakaway == -1 && showAllBullish) {
         pattern = "BREAKAWAY";
         if (isDowntrend(bar + 3, 2, 0.0f, true, true, true)  &&
             getBodySize(bar + 4) >= 2 * getBodySize(bar + 3) &&
             isDowntrend(bar + 1, 3, 0.0f, true, false) &&
             isUptrend(bar, 2) && Close[bar] >= Open[bar + 3]
         ) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //three white soldiers
      if (showBullishThreeWhiteSoldiers >= 1 || showBullishThreeWhiteSoldiers == -1 && showAllBullish) {
         pattern = "THREE WHITE SOLDIERS";
         if (isUptrend(bar, 3, 3.0 * Point, true, false, true) && isLongBodied(bar) && isLongBodied(bar + 1) && isLongBodied(bar + 2)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish separating lines
      if (showBullishSeparatingLines >= 1 || showBullishSeparatingLines == -1 && showAllBullish) {
         pattern = "SEPARATING LINES";
         if (isBullish(bar) && isBearish(bar + 1) && isLongBodied(bar) && isLongBodied(bar + 1) &&
            isUptrend(bar, 2, 0.0f, true, true, false, true)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish squeeze alert
      if (showBullishSqueezeAlert >= 1 || showBullishSqueezeAlert == -1 && showAllBullish) {
         pattern = "SQUEEZE ALERT";
         if (isInsideBar(bar, bar + 1) && isInsideBar(bar + 1, bar + 2) && isBearish(bar + 2)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //descent block
      if (showBullishDescentBlock >= 1 || showBullishDescentBlock == -1 && showAllBullish) {
         pattern = "DESCENT BLOCK";
         if (isDowntrend(bar, 3, 0.0f, true, true, true, false, true)
         && isLongBodied(bar + 2) && isLongBodied(bar + 1) && isLongBodied(bar)
         && getBodySize(bar + 2) > getBodySize(bar + 1) && getBodySize(bar + 1) > getBodySize(bar)
         && getLowerShadowSize(bar + 2) < getLowerShadowSize(bar + 1) && getLowerShadowSize(bar + 1) < getLowerShadowSize(bar)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish deliberation block
      if (showBullishDeliberationBlock >= 1 || showBullishDeliberationBlock == -1 && showAllBullish) {
         pattern = "DELIBERATION BLOCK";
         if (isDowntrend(bar, 2, 0.0, true, true, true, true) && getBodySize(bar) < getBodySize(bar + 1) && getBodySize(bar) <= 5 * Point && isBearish(bar + 2) && isDowntrend(bar + 1, 2, 0.0) && isLongBodied(bar) && isLongBodied(bar + 1) && isLongBodied(bar + 2)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish tri star
      if (showBullishTriStar >= 1 || showBullishTriStar == -1 && showAllBullish) {
         pattern = "TRI STAR";
         if (isDoji(bar) && isDoji(bar + 1) && isDoji(bar + 2) && Open[bar + 1] < Open[bar + 2] && Open[bar + 1] < Open[bar] && Open[bar] < Open[bar + 2]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish abandoned baby
      if (showBullishAbandonedBaby >= 1 || showBullishAbandonedBaby == -1 && showAllBullish) {
         pattern = "ABANDONED BABY";
         if (isBullish(bar) && isBearish(bar + 2) && getBodySize(bar + 1) <= 5 * Point && isLongBodied(bar) && isLongBodied(bar + 2) && getLength(bar + 1) < getLength(bar) && Low[bar] > High[bar + 1] && Close[bar] < Open[bar + 2] && Low[bar + 2] > High[bar + 1]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //morning doji star
      if (showBullishMorningDojiStar >= 1 || showBullishMorningDojiStar == -1 && showAllBullish) {
         pattern = "MORNING DOJI STAR";
         if (isBullish(bar) && isBearish(bar + 2) && isDoji(bar + 1) && isLongBodied(bar) && isLongBodied(bar + 2) && getLength(bar + 1) < getLength(bar) && getLength(bar + 1) < getLength(bar + 2) && Open[bar] >= High[bar + 1] && Close[bar] < Open[bar + 2] && Close[bar + 2] >= High[bar + 1]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //morning star
      if (showBullishMorningStar >= 1 || showBullishMorningStar == -1 && showAllBullish) {
         pattern = "MORNING STAR";
         if (!isDoji(bar + 1) && isBullish(bar) && isBearish(bar + 2) && isDowntrend(bar + 1, 2, 0.0f, true, true, false, false, true) && isUptrend(bar, 2, 0.0f, true, true, false, false, true)
         && Close[bar] < Open[bar + 2] && Close[bar] > Close[bar + 2] && getLength(bar + 1) < getLength(bar) && getLength(bar + 1) < getLength(bar + 2) && getLength(bar) >= 0.5 * getLength(bar + 2) && isLongBodied(bar) && isLongBodied(bar + 2)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //two rabbits
      if (showBullishTwoRabbits >= 1 || showBullishTwoRabbits == -1 && showAllBullish) {
         pattern = "TWO RABBITS";
         if (isBullish(bar) && isBullish(bar + 1) && isBearish(bar + 2) && isLongBodied(bar + 2) && isLongBodied(bar + 1)
         && isLongBodied(bar) && Close[bar + 1] <= Close[bar + 2] && Open[bar] >= Open[bar + 1] &&
         Open[bar] <= Close[bar + 1] && Close[bar] <= Open[bar + 2] && Close[bar] >= Close[bar + 2]
         && getLength(bar) >= 0.5 * getLength(bar + 2)
         ) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //inverted hammer
      if (showBullishInvertedHammer >= 1 || showBullishInvertedHammer == -1 && showAllBullish) {
         pattern = "INVERTED HAMMER";
         if (isDowntrend(bar, 2) && hasLongUpperWickWithAlmostToNoneLowerWick(bar, 1.9)
         && getUpperShadowSize(bar) >= 1.75 * getUpperShadowSize(bar + 1)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish harami cross
      if (showBullishHaramiCross >= 1 || showBullishHaramiCross == -1 && showAllBullish) {
         pattern = "HARAMI CROSS";
         if (isDoji(bar) && isBearish(bar + 1) && isInsideBar(bar, bar + 1)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish doji star
      if (showBullishDojiStar >= 1 || showBullishDojiStar == -1 && showAllBullish) {
         pattern = "DOJI STAR";
         if (isBearish(bar + 1) && isLongBodied(bar + 1) && isDowntrend(bar, 2, 0.0f, true, true, false, true, true) && isDoji(bar) && High[bar] <= Close[bar + 1]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //hammer
      if (showBullishHammer >= 1 || showBullishHammer == -1 && showAllBullish) {
         pattern = "HAMMER";
         if (isDowntrend(bar, 2) && hasLongLowerWickWithAlmostToNoneUpperWick(bar, 1.9) && getLowerShadowSize(bar) >= 1.75 * getLowerShadowSize(bar + 1)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //unique three river bottom
      if (showBullishUniqueThreeRiverBottom >= 1 || showBullishUniqueThreeRiverBottom == -1 && showAllBullish) {
         pattern = "UNIQUE THREE RIVER BOTTOM";
         if (isBullish(bar) && isBearish(bar + 1) && isBearish(bar + 2) && isInsideBar(bar + 1, bar + 2, true, true, false, false) && High[bar + 1] < Low[bar + 2]
         && Close[bar] > Close[bar + 2] && getLength(bar) < getUpperShadowSize(bar + 1)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //piercing line
      if (showBullishPiercingLine >= 1 || showBullishPiercingLine == -1 && showAllBullish) {
         pattern = "PIERCING LINE";
         if (isBullish(bar) && isBearish(bar + 1) && isDowntrend(bar, 2) && Close[bar] > getMiddleBodyPos(bar + 1) && Close[bar] < Open[bar + 1] && isLongBodied(bar) && isLongBodied(bar + 1)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //downside gap two rabbits
      if (showBullishDownsideGapTwoRabbits >= 1 || showBullishDownsideGapTwoRabbits == -1 && showAllBullish) {
         pattern = "DOWNSIDE GAP TWO RABBITS";
         if (isBullish(bar) && isBullish(bar + 1) && isBearish(bar + 2) && High[bar + 1] <= Close[bar + 2] && isInsideBar(bar + 1, bar)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //three outside up
      if (showBullishThreeOutsideUp >= 1 || showBullishThreeOutsideUp == -1 && showAllBullish) {
         pattern = "THREE OUTSIDE UP";
         if (isBullish(bar) && isBullish(bar + 1) && isBearish(bar + 2) && isInsideBar(bar + 2, bar + 1, false, false, false, false) && Close[bar] > Close[bar + 1]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish engulfing
      if (showBullishEngulfing >= 1 || showBullishEngulfing == -1 && showAllBullish) {
         pattern = "ENGULFING";
         if (isBullish(bar) && isBearish(bar + 1) && isInsideBar(bar + 1, bar, false, false, false, false) && High[bar + 1] <= Close[bar]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish three inside up
      if (showBullishThreeInsideUp >= 1 || showBullishThreeInsideUp == -1 && showAllBullish) {
         pattern = "THREE INSIDE UP";
         if (isBullish(bar) && isBullish(bar + 1) && isBearish(bar + 2) && isInsideBar(bar + 1, bar + 2, false, false, false, false) && isLongBodied(bar) && Close[bar] > Close[bar + 1]
            && getBodySize(bar + 1) >= 0.4 * getBodySize(bar + 2)
         ) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish harami
      if (showBullishHarami >= 1 || showBullishHarami == -1 && showAllBullish) {
         pattern = "HARAMI";
         if (isBullish(bar) && isBearish(bar + 1) && isInsideBar(bar, bar + 1, false, false, false, false) && isLongBodied(bar)
         && getBodySize(bar) >= 0.4 * getBodySize(bar + 1)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish meeting line
      if (showBullishMeetingLine >= 1 || showBullishMeetingLine == -1 && showAllBullish) {
         pattern = "MEETING LINE";
         if (isBullish(bar) && isBearish(bar + 1) && isLongBodied(bar) && isLongBodied(bar + 1) && isDowntrend(bar, 2, 0.0f, true, true, false, true)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //homing pigeon
      if (showBullishHomingPigeon >= 1 || showBullishHomingPigeon == -1 && showAllBullish) {
         pattern = "HOMING PIGEON";
         if (isBearish(bar) && isBearish(bar + 1) && isInsideBar(bar, bar + 1, false, false, false, false)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //matching low
      if (showBullishMatchingLow >= 1 || showBullishMatchingLow == -1 && showAllBullish) {
         pattern = "MATCHING LOW";
         if (isBearish(bar) && isBearish(bar + 1) && isLongBodied(bar) && isLongBodied(bar + 1) && Open[bar + 1] > Open[bar] && Close[bar] == Close[bar + 1]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //one white soldier
      if (showBullishOneWhiteSoldier >= 1 || showBullishOneWhiteSoldier == -1 && showAllBullish) {
         pattern = "ONE WHITE SOLDIER";
         if (isBullish(bar) && isBearish(bar + 1) && isUptrend(bar, 2) && Open[bar] < Open[bar + 1]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //rising three methods
      if (showBullishRisingThreeMethods >= 1 || showBullishRisingThreeMethods == -1 && showAllBullish) {
         pattern = "RISING THREE METHODS";
         if (isBullish(bar) && isBullish(bar + 4) && isLongBodied(bar) && isLongBodied(bar + 4) && isDowntrend(bar + 1, 3, 0.0f, false, false) &&
            isInsideBar(bar + 3, bar + 4, false, false, false, false) && isInsideBar(bar + 2, bar + 4, false, false, false, false) && isInsideBar(bar + 1, bar + 4, false, false, false, false)
            && Close[bar] > Close[bar + 4]
            ) {
               drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //upside tasuki gap
      if (showBullishUpsideTasukiGap >= 1 || showBullishUpsideTasukiGap == -1 && showAllBullish) {
         pattern = "UPSIDE TASUKI GAP";
         if (isBearish(bar) && isBullish(bar + 1) && isBullish(bar + 2) && High[bar + 2] < Low[bar + 1] && Close[bar] >= High[bar + 2] && High[bar] <= Open[bar + 1]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //upside gap three methods
      if (showBullishUpsideGapThreeMethods >= 1 || showBullishUpsideGapThreeMethods == -1 && showAllBullish) {
         pattern = "UPSIDE GAP THREE METHODS";
         if (isBearish(bar) && isBullish(bar + 1) && isBullish(bar + 2) && High[bar + 2] <= Low[bar + 1] && Open[bar] >= Open[bar + 1] && Open[bar] < Close[bar + 1] && Close[bar] <= Close[bar + 2] && Close[bar] > Open[bar + 2]) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish in neck
      if (showBullishInNeck >= 1 || showBullishInNeck == -1 && showAllBullish) {
         pattern = "IN NECK";
         if (isBullish(bar + 1) && isBearish(bar) && isLongBodied(bar + 1) && Open[bar] > High[bar + 1] && Close[bar] >= Close[bar + 1] - 2 * Point && Close[bar] < Close[bar + 1] && Close[bar] > Open[bar + 1] && getBodySize(bar) < getBodySize(bar + 1)){
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //bullish on neck
      if (showBullishOnNeck >= 1 || showBullishOnNeck == -1 && showAllBullish) {
         pattern = "ON NECK";
         if (isBullish(bar + 1) && isBearish(bar) && isLongBodied(bar + 1) && isLongBodied(bar) && Close[bar] == High[bar + 1] && getBodySize(bar) < getBodySize(bar + 1)){
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
      //Bullish Side by Side White Lines
      if (showBullishSideBySideWhiteLines >= 1 || showBullishSideBySideWhiteLines == -1 && showAllBullish) {
         pattern = "BULLISH SIDE BY SIDE WHITE LINES";
         if (isBullish(bar) && isBullish(bar + 1) && isBullish(bar + 2) && fabs(getBodySize(bar) - getBodySize(bar + 1)) <= Point && fabs(Open[bar] - Open[bar + 1]) <= Point && Open[bar] >= Close[bar + 2] && isLongBodied(bar) && isLongBodied(bar + 1) && isLongBodied(bar + 2)) {
            drawBullish(bar, Pointer_Offset, CumOffset, IncOffset, pattern);
         }
         else
            destroyBullish(bar, pattern, CumOffset);
      }
      
   }
}
